//+------------------------------------------------------------------+
//|                                                   CCI.mq4 |
//|                                 Copyright  2007,   |
//|                                                                  |
//| ,   CCI              |
//|  GBPUSD    30                           |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007,  "
#property link      "http://"
#include <stderror.mqh>
#include <stdlib.mqh>

#define MAGICMA  53370742      //  ,             

extern double Lots                  =0.1;
extern double iCperiod              =14;        // 
extern double iClvlBUY              =-100;      //  CCI
extern double iClvlSELL             =100;        //  CCI

extern double TrailingStopSELL      =25;        //Trailing Stop    
extern double TrailingStopBUY       =30;        //Trailing Stop    
extern double TakeProfit            =300;       //TakeProfit
extern double MaxLots               =1;
extern double Slippage              =3;         //

int           i;
int           fhandle;                          // 
int           ticket;                           //Ticket
string        SymbolName            ="GBPUSD";
int           period                =PERIOD_M30;
int           NArrow;                           // 

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
      SymbolName=Symbol();
      period=Period();
      Comment(SymbolName,",M",period,",",Point);
      FileDelete("CCI_"+SymbolName+".csv");
       fhandle=FileOpen("CCI_"+SymbolName+".csv",FILE_WRITE|FILE_CSV,"\t");
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
      FileClose(fhandle);   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
bool DrawArrow(int ARROW_TYPE)
{
  //   
    if(!ObjectCreate("a"+DoubleToStr(NArrow,0), OBJ_ARROW, 0, iTime(SymbolName,0,0),iClose(SymbolName,0,0)))
    {
     Print(":     ",GetLastError());
     return(0);
    }
    else
    {
      ObjectSet("a"+DoubleToStr(NArrow,0), OBJPROP_ARROWCODE, ARROW_TYPE);
      NArrow++;
    }

}
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
      if(OrderSymbol()==SymbolName && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
//|                          |
//+------------------------------------------------------------------+
int CalculateBySellOrders(string symbol, int buysell)
  {
   int orders=0;
//----
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) continue;
      if(OrderSymbol()==SymbolName && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==buysell)  orders++;
        }
     }
   return(orders);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  bool      fl;
  double    iCTek,iCPrev;
  double    StopLossBUY,StopLossSELL;
  bool      bCSignalBUYClose,bCSignalSELLClose; //    
  bool      bCSignalBUY,bCSignalSELL;           //     CCI
  int       total;                              //  
  int       err;
  bool      ret;
  int       ticket;
  
  iCTek=iCCI(SymbolName,period,iCperiod,PRICE_CLOSE,0);
  iCPrev=iCCI(SymbolName,period,iCperiod,PRICE_CLOSE,1);
  
  //if((iCTek>iClvlBUY && iCPrev<=iClvlBUY)|| (iCTek>0 && iCPrev<=0))
  if(iCTek>iClvlBUY && iCPrev<=iClvlBUY)
  {
   //    CCI
      bCSignalBUY=true;
  }
  else
  {
      bCSignalBUY=false;
  }
  
  if(iCTek<iClvlSELL && iCPrev>=iClvlSELL)
  {
   //    CCI
      bCSignalSELL=true;
  }
  else
  {
      bCSignalSELL=false;
  }
  
  //if(iCTek<=iClvlBUY && bCSignalBUY==true)
  if(iCTek<=iClvlBUY && iCPrev>iClvlBUY)
  {
      //      
      bCSignalBUYClose=true;
      bCSignalBUY=false;
      FileWrite(fhandle,"  ");
               DrawArrow(SYMBOL_ARROWDOWN);
  }
  else
  {
      bCSignalBUYClose=false;
  }
  
  //if(iCTek>=iClvlSELL && bCSignalSELL==true)
  if(iCTek>=iClvlSELL && iCPrev<iClvlSELL)
  {
   //      
      bCSignalSELLClose=true;
      bCSignalSELL=false;
      FileWrite(fhandle,"  ");
               DrawArrow(SYMBOL_ARROWUP);
  }
  else
  {
      bCSignalSELLClose=false;
  }

  FileWrite(fhandle,"iCTek= ",iCTek,"iCPrev= ",iCPrev,"bCSignalSELL= ",bCSignalSELL,
  "bCSignalBUY= ",bCSignalBUY,"bCSignalBUYClose= ",bCSignalBUYClose,"bCSignalSELLClose= ",bCSignalSELLClose);

   total=CalculateCurrentOrders(SymbolName);
   StopLossBUY=MaxLots*TrailingStopBUY*Point+10*Point;
   StopLossSELL=MaxLots*TrailingStopSELL*Point+10*Point;

// 
    if(bCSignalBUY==true && CalculateBySellOrders(SymbolName,OP_BUY)==0)
      {
               //...         
                     GetLastError();
                     ticket=OrderSend(SymbolName,OP_BUY,Lots,Ask,3,Bid-StopLossBUY,Ask+TakeProfit*Point,"",MAGICMA,0,Green);
                     if(ticket<0)
                        {
                           err=GetLastError();
                           FileWrite(fhandle,"   : ",ErrorDescription(err));
                        }
                     else
                        {
                           OrderSelect(ticket,SELECT_BY_TICKET);  //  OrderPrice  ..
                           bCSignalBUY=false;
                           FileWrite(fhandle,"    ", ticket,OrderOpenPrice(),OrderOpenTime(),OrderSymbol(),OrderLots());
                        }
      }
    if(bCSignalSELL==true && CalculateBySellOrders(SymbolName,OP_SELL)==0)
      {
               //...         
                     GetLastError();
                     ticket=OrderSend(SymbolName,OP_SELL,Lots,Bid,3,Ask+StopLossSELL,Bid-TakeProfit*Point,"",MAGICMA,0,Red);
                     if(ticket<0)
                        {
                           err=GetLastError();
                           FileWrite(fhandle,"   : ",ErrorDescription(err));
                        }
                     else
                        {
                           OrderSelect(ticket,SELECT_BY_TICKET);
                           bCSignalSELL=false;
                           FileWrite(fhandle,"    ",ticket,OrderOpenPrice(),OrderOpenTime(),OrderSymbol(),OrderLots());
                        }
      }

//   
   for(i=0;i<total;i++)
     {
      fl=OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(fl==true && OrderSymbol()==SymbolName && OrderMagicNumber()==MAGICMA)  //  
        {
        ticket=OrderTicket();
         if(OrderType()==OP_BUY)   //    
           {
            if(bCSignalBUYClose==true)
            {
            //      
               FileWrite(fhandle,"  "+ticket+"    ");
               RefreshRates();
               //ret=OrderClose(ticket,OrderLots(),MarketInfo(Symbol(),MODE_BID),3,Violet);
               ret=OrderClose(ticket,Lots,Bid,3,Violet);
               DrawArrow(SYMBOL_ARROWDOWN);
               if(ret==false)
               {
                  //    
                   err=GetLastError();
                   FileWrite(fhandle,"    : ",ErrorDescription(err));
               }
               else
               {
                   FileWrite(fhandle,"   "+ticket+"   ");
                   DrawArrow(SYMBOL_THUMBSDOWN);
               }
            }
            else if(TrailingStopBUY>0)  
            {                 
            //       - ,    TrailingStop
               if((Bid-OrderOpenPrice())>(Point*TrailingStopBUY))
                 {
                  if(OrderStopLoss()<(Bid-Point*TrailingStopBUY))
                    {
                     OrderModify(ticket,OrderOpenPrice(),Bid-Point*TrailingStopBUY,OrderTakeProfit(),0,Green);
                     //OrderModify(ticket,OrderOpenPrice(),Bid-StopLossBUY,OrderTakeProfit(),0,Green);
                     FileWrite(fhandle,"     ",ticket,OrderOpenPrice(),
                                        OrderOpenTime(),Bid-Point*TrailingStopBUY,OrderTakeProfit());
                    }
                 }
             }//else if(TrailingStop>0)
           }//if(OrderType()==OP_BUY)
         else  //   
           {
            if(bCSignalSELLClose==true)
            {
            //      
               FileWrite(fhandle,"  "+ticket+"    ");
               RefreshRates();
               //ret=OrderClose(ticket,OrderLots(),MarketInfo(Symbol(),MODE_ASK),3,Violet);
               ret=OrderClose(ticket,Lots,Ask,3,Violet);
               DrawArrow(SYMBOL_ARROWUP);
               if(ret==false)
               {
                  //    
                   err=GetLastError();
                   FileWrite(fhandle,"    : ",ErrorDescription(err));
               }
               else
               {
                   FileWrite(fhandle,"   "+ticket+"   ");
                   DrawArrow(SYMBOL_THUMBSUP);
               }
            }
            //       - ,    TrailingStop
            else if(TrailingStopSELL>0)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStopSELL))
                 {
                  if(OrderStopLoss()>(Ask+Point*TrailingStopSELL))
                    {
                     OrderModify(ticket,OrderOpenPrice(),Ask+Point*TrailingStopSELL,OrderTakeProfit(),0,Red);
                     //OrderModify(ticket,OrderOpenPrice(),Ask+StopLossSELL,OrderTakeProfit(),0,Red);
                     FileWrite(fhandle,"     ",ticket,OrderOpenPrice(),
                                       OrderOpenTime(),Ask+Point*TrailingStopSELL,OrderTakeProfit());
                    }
                 }
              }//if(TrailingStop>0)
           }//if(OrderType()==OP_SELL)
        }//if(fl==true && OrderSymbol()==SymbolName)
      }//for
}//start